CON
  XWIDTH_MAX = 32
  YWIDTH_MAX = 15
  XPOS_COMMAND = $0A
  YPOS_COMMAND = $0B
  COLOR_COMMAND = $0C
      
VAR
  long winBuffer_ptr
  byte title[XWIDTH_MAX] 'reserve memory for the window title
  byte winBuffer[XWIDTH_MAX*YWIDTH_MAX]
  byte textField[XWIDTH_MAX*YWIDTH_MAX]
  
' init: in objectoriented programming this should be the constructor
PUB init
  'bytemove(@winBuffer,string(13,"yes  "),100)    ' string copy
  winBuffer_ptr:=@winBuffer
  setTitle(string("haeh ?"))
  setText(string("my text"))

' returns a pointer to a string which represents the window content
PUB update | stringptr,n
  winBuffer_ptr:=@winBuffer

  makePos(xpos,ypos)
  makeColor(6)
  'copy title
  stringptr:=@title
  repeat n from 0 to strsize(stringptr)
    byte[winBuffer_ptr++]:=byte[stringptr++]

  makePos(xpos,ypos+1)
  makeColor(7)
  'copy textField   
  stringptr:=@textField
  repeat n from 0 to strsize(stringptr)+4
    byte[winBuffer_ptr++]:=byte[stringptr++]
  
  byte[winBuffer_ptr]:=0 'string termination sign
  
  result:=@winBuffer

 
PUB setTitle(stringptr)|n
  repeat n from 0 to strsize(stringptr)
    title[n]:=byte[stringptr++]
  'bytemove(@title,@byte[stringptr],XMAX)

PUB setText(stringptr)|n
  repeat n from 0 to strsize(stringptr)
    textField[n]:=byte[stringptr++]
    
PUB setPos(x,y)
  xpos:=x
  ypos:=y

PRI makePos(x,y)
  byte[winBuffer_ptr++]:=XPOS_COMMAND
  byte[winBuffer_ptr++]:=x
  byte[winBuffer_ptr++]:=YPOS_COMMAND
  byte[winBuffer_ptr++]:=y

PRI makeColor(color)
  byte[winBuffer_ptr++]:=COLOR_COMMAND
  byte[winBuffer_ptr++]:=color
 
DAT
xpos byte 1
ypos byte 1